<?php
/**
* @copyright	Copyright (C) 2009 - 2009 Ready Bytes Software Labs Pvt. Ltd. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* @package		PayPlans
* @subpackage	My SQL query
* @contact 		shyam@readybytes.in
* 
*/
if(defined('_JEXEC')===false) die();

class PayplansAppMysqlquery extends PayplansApp
{
	protected $_location	= __FILE__;

	public function onPayplansSubscriptionAfterSave($prev, $new)
	{
		// no need to trigger if previous and current state is same
		if($prev != null && $prev->getStatus() == $new->getStatus()){
			return true;
		}
		
		$newStatus  = $new->getStatus();
		
		//get all params
		$useDefaultDb			= $this->getAppParam('use_default_db');
		$db = XiFactory::getDBO();
		if(! $useDefaultDb){
			$options = array( 'host'		=> $this->getAppParam('db_host'),
							  'user'		=> $this->getAppParam('db_username'),
						  	  'password'	=> $this->getAppParam('db_password'),
							  'database'	=> $this->getAppParam('db_name'),
							  'prefix'		=> $this->getAppParam('table_prefix')
							);

		   $db = JDatabase::getInstance($options);
		}
		
				
		$queryOnActive = $this->getAppParam('queryOnActive','');
		$queryOnHold   = $this->getAppParam('queryOnHold','');
		$queryOnExpire = $this->getAppParam('queryOnExpire','');
				

		// if subscription is active
		if($newStatus == PayplansStatus::SUBSCRIPTION_ACTIVE){										
			$query = $queryOnActive;
		}
		
		//if subscription is hold
		if($newStatus == PayplansStatus::SUBSCRIPTION_HOLD){					
			$query = $queryOnHold;
		}
		// if subscription is active
		if($newStatus == PayplansStatus::SUBSCRIPTION_EXPIRED){						
			$query = $queryOnExpire;
		}
		$this->_executeQuery($db,$query,$new);
		return true;
	}
	
	protected function _executeQuery($db,$query,$object)
	{
		if(empty($query)){
			return true;
		}
		$query 		= XiHelperPatch::_filterComments($query);
		//split input query in multiple queries
		$queries	= $db->splitSql($query);
		foreach ($queries as $sqlQuery){
			$query1 = payplansFactory::getRewriter()->rewrite($sqlQuery, $object);
			$db->setQuery( $query1 );
			if ( !$db->query() ) {
				$this->error = "MYSQL ERROR: " . $db->stderr();
			}
		}
		return true;	
	}
	
}
